=begin
#Quandoo API Documentation

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.5

=end

require 'uri'

module Quandoo
  class ReservationSettingsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get merchant reservation settings
    # This endpoint provides all data that is required to initiate the reservation flow and is not part of the search endpoint.  Example curl: ``` curl https://{host}/v{X}/merchants/15/reservation-settings ```  Example response:  ``` {   \"areaIds\": [     {       \"id\": 2,       \"name\": \"Garden\",       \"priority\": 10     }   ],   \"areaSelectionRequired\": true,   \"capacities\": [     1,     2,     3,     4,     5,     6   ],   \"links\": [     {       \"href\": \"https://{host}/v{X}/merchants/15\",       \"method\": \"GET\",       \"rel\": \"parent\"     },     {       \"href\": \"https://{host}/v{X}/merchants/15/availabilities\",       \"method\": \"GET\",       \"rel\": \"availability_days\"     },     {       \"href\": \"https://{host}/v{X}/merchants/15/availabilities/2017-01-01/times\",       \"method\": \"GET\",       \"rel\": \"availability\"     }   ],   \"merchantNewsletterSelectionRequired\": true,   \"minimumCapacityForEnquiries\": 10,   \"onlineReservationInterval\": 60,   \"reservationEnquiryEnabled\": true,   \"specialTerms\": \"This is any custom string for special terms\",   \"automaticConfirmation\": true,   \"ccvEnabled\": true } ``` 
    # @param merchant_id Id of the merchant
    # @param [Hash] opts the optional parameters
    # @return [MerchantReservationSettingsDto]
    def reservation_settings1(merchant_id, opts = {})
      data, _status_code, _headers = reservation_settings1_with_http_info(merchant_id, opts)
      data
    end

    # Get merchant reservation settings
    # This endpoint provides all data that is required to initiate the reservation flow and is not part of the search endpoint.  Example curl: &#x60;&#x60;&#x60; curl https://{host}/v{X}/merchants/15/reservation-settings &#x60;&#x60;&#x60;  Example response:  &#x60;&#x60;&#x60; {   \&quot;areaIds\&quot;: [     {       \&quot;id\&quot;: 2,       \&quot;name\&quot;: \&quot;Garden\&quot;,       \&quot;priority\&quot;: 10     }   ],   \&quot;areaSelectionRequired\&quot;: true,   \&quot;capacities\&quot;: [     1,     2,     3,     4,     5,     6   ],   \&quot;links\&quot;: [     {       \&quot;href\&quot;: \&quot;https://{host}/v{X}/merchants/15\&quot;,       \&quot;method\&quot;: \&quot;GET\&quot;,       \&quot;rel\&quot;: \&quot;parent\&quot;     },     {       \&quot;href\&quot;: \&quot;https://{host}/v{X}/merchants/15/availabilities\&quot;,       \&quot;method\&quot;: \&quot;GET\&quot;,       \&quot;rel\&quot;: \&quot;availability_days\&quot;     },     {       \&quot;href\&quot;: \&quot;https://{host}/v{X}/merchants/15/availabilities/2017-01-01/times\&quot;,       \&quot;method\&quot;: \&quot;GET\&quot;,       \&quot;rel\&quot;: \&quot;availability\&quot;     }   ],   \&quot;merchantNewsletterSelectionRequired\&quot;: true,   \&quot;minimumCapacityForEnquiries\&quot;: 10,   \&quot;onlineReservationInterval\&quot;: 60,   \&quot;reservationEnquiryEnabled\&quot;: true,   \&quot;specialTerms\&quot;: \&quot;This is any custom string for special terms\&quot;,   \&quot;automaticConfirmation\&quot;: true,   \&quot;ccvEnabled\&quot;: true } &#x60;&#x60;&#x60; 
    # @param merchant_id Id of the merchant
    # @param [Hash] opts the optional parameters
    # @return [Array<(MerchantReservationSettingsDto, Fixnum, Hash)>] MerchantReservationSettingsDto data, response status code and response headers
    def reservation_settings1_with_http_info(merchant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ReservationSettingsApi.reservation_settings1 ...'
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling ReservationSettingsApi.reservation_settings1"
      end
      # resource path
      local_var_path = '/v1/merchants/{merchantId}/reservation-settings'.sub('{' + 'merchantId' + '}', merchant_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'MerchantReservationSettingsDto')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ReservationSettingsApi#reservation_settings1\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
