=begin
#Quandoo API Documentation

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.5

=end

require 'uri'

module Quandoo
  class ReservationsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create reservations
    # This endpoint allows to create a reservation for a certain capacity, date and time. It also requires certain customer information. All optional fields can be either omitted or set to null. The endpoint is idempotent, which means sending the same request twice will not create another reservation. For that purpose the client is required to generate an agent-specific unique ID for the reservation.  The endpoint will return status `HTTP 409` should the reservation option specified by the given parameters not be bookable anymore. The endpoint will return status `HTTP 400` should any of the required parameters be missing or formatted incorrectly. See schema for details.   ####Request: The request needs to have 3 objects for reservation, customer and tracking information.  * **reservation**: Information about the reservation.   * **id**: The identifier of the reservation for the calling agent (Agent-dependent field). Optional.   * **merchantId**: The ID of the merchant at which this reservation will be made. **Required**.   * **capacity**: The capacity (people count) of the reservation. **Required**.   * **areaId**: The ID of the area this reservation should be in. Optional.   * **dateTime**: The date and time when the reservation will take place. Format: yyyy-MM-ddTHH:mm:ssZ. **Required**     * Z can be used, example: `2019-03-23T19:15:00Z` meaning UTC     * a time zone offset can be specified, example: `2019-03-23T20:15:00+01:00`   * **orderId**: The id of the order to which this reservation is associated. Optional.   * **extraInfo**: Any extra information that the customer likes to provide. Optional.   * **promoCode**: A promotion code which should be used with this reservation. Optional.   * **creditCardVaultSettingsId**: A credit card vault settings to be used by this reservation. Optional.   * **recurringCardDetailId**:A customer credit card reference to be used if credit card vault should be applied. Optional.   * **deals**: A list of deals which should be used with this reservation. Type can be SPECIAL, OFFER or DISCOUNT. Optional.  * **customer**: Information on the customer making the reservation.   * **id**: Identifier of the customer for the calling agent. Agent dependent field. Optional.   * **firstName**: The first name of the customer. Optional.   * **lastName**: The last name of the customer. Optional.   * **emailAddress**: The email address of the customer. **Required**.   * **phoneNumber**: The phone number of the customer. Without country code, since it will be assumed from the country field. Example: 030120765890. **Required**.   * **locale**: The locale of the customer. E.g. de_DE. **Required**.   * **country**: The 2 letter ISO country of the customer. E.g DE. **Required**   * **subscriptions**: List of requested subscriptions e.g. QUANDOO, MERCHANT. Optional.  * **tracking**: Third party information used to track customer and reservations.   * **agent**: The id of the agent creating this request and partner references if any. **Required**.   * **cookie**: Cookie information to be stored with this reservation. Optional.  ####Response: The response returns information on the created reservation and the customer along with relevant links to follow.  * **reservation**: Information on the created reservation.   * **id**: Agent-specific id set for the reservation.   * **number**: Quandoo internal identifier of the reservation.   * **status**: Status for the created reservation. eg. \"CREATED\"   * **quandooId**: Quandoo public identifier for the reservation.    * **customer**: Information on the customer making the reservation.   * **id**: Agent-specific id set for the customer.  * **links**: Related links that can be followed based on this response.  Example curl: ``` curl -H \"Content-Type: application/json\" -X POST -d ' {     \"reservation\": {         \"id\": \"07f53b36-3f48-11e5-a151-feff819cdc9f\",         \"merchantId\": 15,         \"capacity\": 2,         \"areaId\": 1,         \"dateTime\": \"2015-06-22T12:00:00+00:00\",         \"orderId\": \"a7e9fa78-b167-4c25-921a-8da675b5f03a\",         \"extraInfo\": \"Some text\",         \"promoCode\": \"PROMO123\",         \"deals\": [             {                 \"id\": \"a7db794d-6a0a-43fb-b680-3b30058af7a8\",                 \"count\": 2,                 \"type\": \"OFFER\"             }         ]      },     \"customer\": {         \"id\": \"659b9f4b-cd1a-4dc9-a5c3-8ef6bacbade5\",         \"firstName\": \"Hans\",         \"lastName\": \"Wurst\",         \"emailAddress\": \"hans.wurst@foo.bar\",         \"phoneNumber\": \"017312345678\",         \"locale\": \"de_DE\",         \"country\": \"DE\",         \"subscriptions\": [           {               \"id\": \"QUANDOO\"           },           {               \"id\": \"MERCHANT\"           }       ]     },     \"tracking\": {         \"agent\": {           \"id\": 3         },         \"cookie\": {             \"tracking\": \"ff819cdc9\",             \"referenceId\": \"07f53b36\"         }     } }' https://{host}/v{X}/reservations ```  Example response: ``` {     \"reservation\": {         \"id\": \"07f53b36-3f48-11e5-a151-feff819cdc9f\",         \"number\": 708457891,         \"status\": \"CREATED\",         \"quandooId\": \"07f53b36-3f48-11e5-a151-feff819cdc9f\"     },     \"customer\": {         \"id\": \"01a53b36-3f48-11e5-a151-feff819cdc9f\"     },     \"links\": [         {            \"href\": \"https://{host}/v{X}/merchants/15/reservation-settings\",            \"method\": \"GET\",            \"rel\": \"parent\"         }     ] } ```
    # @param body Reservation data
    # @param [Hash] opts the optional parameters
    # @return [CreatedReservationData]
    def create_reservation1(body, opts = {})
      data, _status_code, _headers = create_reservation1_with_http_info(body, opts)
      data
    end

    # Create reservations
    # This endpoint allows to create a reservation for a certain capacity, date and time. It also requires certain customer information. All optional fields can be either omitted or set to null. The endpoint is idempotent, which means sending the same request twice will not create another reservation. For that purpose the client is required to generate an agent-specific unique ID for the reservation.  The endpoint will return status &#x60;HTTP 409&#x60; should the reservation option specified by the given parameters not be bookable anymore. The endpoint will return status &#x60;HTTP 400&#x60; should any of the required parameters be missing or formatted incorrectly. See schema for details.   ####Request: The request needs to have 3 objects for reservation, customer and tracking information.  * **reservation**: Information about the reservation.   * **id**: The identifier of the reservation for the calling agent (Agent-dependent field). Optional.   * **merchantId**: The ID of the merchant at which this reservation will be made. **Required**.   * **capacity**: The capacity (people count) of the reservation. **Required**.   * **areaId**: The ID of the area this reservation should be in. Optional.   * **dateTime**: The date and time when the reservation will take place. Format: yyyy-MM-ddTHH:mm:ssZ. **Required**     * Z can be used, example: &#x60;2019-03-23T19:15:00Z&#x60; meaning UTC     * a time zone offset can be specified, example: &#x60;2019-03-23T20:15:00+01:00&#x60;   * **orderId**: The id of the order to which this reservation is associated. Optional.   * **extraInfo**: Any extra information that the customer likes to provide. Optional.   * **promoCode**: A promotion code which should be used with this reservation. Optional.   * **creditCardVaultSettingsId**: A credit card vault settings to be used by this reservation. Optional.   * **recurringCardDetailId**:A customer credit card reference to be used if credit card vault should be applied. Optional.   * **deals**: A list of deals which should be used with this reservation. Type can be SPECIAL, OFFER or DISCOUNT. Optional.  * **customer**: Information on the customer making the reservation.   * **id**: Identifier of the customer for the calling agent. Agent dependent field. Optional.   * **firstName**: The first name of the customer. Optional.   * **lastName**: The last name of the customer. Optional.   * **emailAddress**: The email address of the customer. **Required**.   * **phoneNumber**: The phone number of the customer. Without country code, since it will be assumed from the country field. Example: 030120765890. **Required**.   * **locale**: The locale of the customer. E.g. de_DE. **Required**.   * **country**: The 2 letter ISO country of the customer. E.g DE. **Required**   * **subscriptions**: List of requested subscriptions e.g. QUANDOO, MERCHANT. Optional.  * **tracking**: Third party information used to track customer and reservations.   * **agent**: The id of the agent creating this request and partner references if any. **Required**.   * **cookie**: Cookie information to be stored with this reservation. Optional.  ####Response: The response returns information on the created reservation and the customer along with relevant links to follow.  * **reservation**: Information on the created reservation.   * **id**: Agent-specific id set for the reservation.   * **number**: Quandoo internal identifier of the reservation.   * **status**: Status for the created reservation. eg. \&quot;CREATED\&quot;   * **quandooId**: Quandoo public identifier for the reservation.    * **customer**: Information on the customer making the reservation.   * **id**: Agent-specific id set for the customer.  * **links**: Related links that can be followed based on this response.  Example curl: &#x60;&#x60;&#x60; curl -H \&quot;Content-Type: application/json\&quot; -X POST -d &#39; {     \&quot;reservation\&quot;: {         \&quot;id\&quot;: \&quot;07f53b36-3f48-11e5-a151-feff819cdc9f\&quot;,         \&quot;merchantId\&quot;: 15,         \&quot;capacity\&quot;: 2,         \&quot;areaId\&quot;: 1,         \&quot;dateTime\&quot;: \&quot;2015-06-22T12:00:00+00:00\&quot;,         \&quot;orderId\&quot;: \&quot;a7e9fa78-b167-4c25-921a-8da675b5f03a\&quot;,         \&quot;extraInfo\&quot;: \&quot;Some text\&quot;,         \&quot;promoCode\&quot;: \&quot;PROMO123\&quot;,         \&quot;deals\&quot;: [             {                 \&quot;id\&quot;: \&quot;a7db794d-6a0a-43fb-b680-3b30058af7a8\&quot;,                 \&quot;count\&quot;: 2,                 \&quot;type\&quot;: \&quot;OFFER\&quot;             }         ]      },     \&quot;customer\&quot;: {         \&quot;id\&quot;: \&quot;659b9f4b-cd1a-4dc9-a5c3-8ef6bacbade5\&quot;,         \&quot;firstName\&quot;: \&quot;Hans\&quot;,         \&quot;lastName\&quot;: \&quot;Wurst\&quot;,         \&quot;emailAddress\&quot;: \&quot;hans.wurst@foo.bar\&quot;,         \&quot;phoneNumber\&quot;: \&quot;017312345678\&quot;,         \&quot;locale\&quot;: \&quot;de_DE\&quot;,         \&quot;country\&quot;: \&quot;DE\&quot;,         \&quot;subscriptions\&quot;: [           {               \&quot;id\&quot;: \&quot;QUANDOO\&quot;           },           {               \&quot;id\&quot;: \&quot;MERCHANT\&quot;           }       ]     },     \&quot;tracking\&quot;: {         \&quot;agent\&quot;: {           \&quot;id\&quot;: 3         },         \&quot;cookie\&quot;: {             \&quot;tracking\&quot;: \&quot;ff819cdc9\&quot;,             \&quot;referenceId\&quot;: \&quot;07f53b36\&quot;         }     } }&#39; https://{host}/v{X}/reservations &#x60;&#x60;&#x60;  Example response: &#x60;&#x60;&#x60; {     \&quot;reservation\&quot;: {         \&quot;id\&quot;: \&quot;07f53b36-3f48-11e5-a151-feff819cdc9f\&quot;,         \&quot;number\&quot;: 708457891,         \&quot;status\&quot;: \&quot;CREATED\&quot;,         \&quot;quandooId\&quot;: \&quot;07f53b36-3f48-11e5-a151-feff819cdc9f\&quot;     },     \&quot;customer\&quot;: {         \&quot;id\&quot;: \&quot;01a53b36-3f48-11e5-a151-feff819cdc9f\&quot;     },     \&quot;links\&quot;: [         {            \&quot;href\&quot;: \&quot;https://{host}/v{X}/merchants/15/reservation-settings\&quot;,            \&quot;method\&quot;: \&quot;GET\&quot;,            \&quot;rel\&quot;: \&quot;parent\&quot;         }     ] } &#x60;&#x60;&#x60;
    # @param body Reservation data
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreatedReservationData, Fixnum, Hash)>] CreatedReservationData data, response status code and response headers
    def create_reservation1_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ReservationsApi.create_reservation1 ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling ReservationsApi.create_reservation1"
      end
      # resource path
      local_var_path = '/v1/reservations'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CreatedReservationData')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ReservationsApi#create_reservation1\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get reservation by id
    # This endpoint allows an agent or a user to get a reservation by id. The id is either agent-specific or a public id. The agent/user needs to be authenticated.  The endpoint will return `HTTP 404 - Not Found` if the reservation with the specified id could not be found.  It will return `HTTP 403 - Forbidden` if the agent/user is not authenticated, if the agent/user doesn't have permissions, if the reservation doesn't belong to the authenticated agent or if the user doesn't have permissions to see objects from the merchant owner of the reservation  ####Request: * **reservationId**: Agent-specific or public ID of the requested reservation  ####Response: * **id**: Agent-specific or public ID of the requested reservation * **number**: Quandoo internal identifier of the reservation * **quandooId**: The public id of this reservation on quandoo system. * **status**: The status of the reservation eg. CREATED, CONFIRMED, CUSTOMER CANCELED etc. * **startTime**: The start time of the reservation. Format: `yyyy-MM-ddTHH:mm:ssZ` * **endTime**: The end time of the reservation. Format: `yyyy-MM-ddTHH:mm:ssZ` * **capacity**: The capacity (people count) of the reservation * **merchantId**: The ID of the merchant at which this reservation was made. * **customerId**: The public ID of the customer to which this reservation belongs * **promoCode**: The promotion code associated with this reservation. Optional. * **extraInfo**: extra information that the customer provided for the reservation. Optional. * **links**: Related links that can be followed based on this response. * **createdAt**: The date the reservation was created. Format: `yyyy-MM-ddTHH:mm:ssZ` * **updatedAt**: The date the reservation was last updated. Format: `yyyy-MM-ddTHH:mm:ssZ`  Example curl: ``` curl https://{host}/v{X}/reservations/07f53b36-3f48-11e5-a151-feff819cdc9f ```  Example response: ``` {   \"id\": \"07f53b36-3f48-11e5-a151-feff819cdc9f\",   \"number\": 1092454812,   \"quandooId\": \"07f53b36-3f48-11e5-a151-feff819cdc9f\",   \"status\": \"CREATED\",   \"startTime\": \"2015-06-22T12:00:00+00:00\",   \"endTime\": \"2015-06-22T13:00:00+00:00\",   \"capacity\": 4,   \"merchantId\": 1384,   \"customerId\": \"35fff464-142c-48ac-a0c6-ed72a1615664\",   \"promocode\": \"SOME_CAMPAIGN_CODE\",   \"extraInfo\": \"request for baby chair\",   \"links\": [     {       \"href\": \"https://{host}/v{X}/reservations/07f53b36-3f48-11e5-a151-feff819cdc9f\",       \"method\": \"PATCH\",       \"rel\": \"update\"     }   ],   \"createdAt\": \"2015-06-01T15:21:54Z\",   \"updatedAt\": \"2015-06-01T18:45:30Z\" } ```
    # @param reservation_id Id of the reservation
    # @param [Hash] opts the optional parameters
    # @return [ReservationData]
    def get_reservation1(reservation_id, opts = {})
      data, _status_code, _headers = get_reservation1_with_http_info(reservation_id, opts)
      data
    end

    # Get reservation by id
    # This endpoint allows an agent or a user to get a reservation by id. The id is either agent-specific or a public id. The agent/user needs to be authenticated.  The endpoint will return &#x60;HTTP 404 - Not Found&#x60; if the reservation with the specified id could not be found.  It will return &#x60;HTTP 403 - Forbidden&#x60; if the agent/user is not authenticated, if the agent/user doesn&#39;t have permissions, if the reservation doesn&#39;t belong to the authenticated agent or if the user doesn&#39;t have permissions to see objects from the merchant owner of the reservation  ####Request: * **reservationId**: Agent-specific or public ID of the requested reservation  ####Response: * **id**: Agent-specific or public ID of the requested reservation * **number**: Quandoo internal identifier of the reservation * **quandooId**: The public id of this reservation on quandoo system. * **status**: The status of the reservation eg. CREATED, CONFIRMED, CUSTOMER CANCELED etc. * **startTime**: The start time of the reservation. Format: &#x60;yyyy-MM-ddTHH:mm:ssZ&#x60; * **endTime**: The end time of the reservation. Format: &#x60;yyyy-MM-ddTHH:mm:ssZ&#x60; * **capacity**: The capacity (people count) of the reservation * **merchantId**: The ID of the merchant at which this reservation was made. * **customerId**: The public ID of the customer to which this reservation belongs * **promoCode**: The promotion code associated with this reservation. Optional. * **extraInfo**: extra information that the customer provided for the reservation. Optional. * **links**: Related links that can be followed based on this response. * **createdAt**: The date the reservation was created. Format: &#x60;yyyy-MM-ddTHH:mm:ssZ&#x60; * **updatedAt**: The date the reservation was last updated. Format: &#x60;yyyy-MM-ddTHH:mm:ssZ&#x60;  Example curl: &#x60;&#x60;&#x60; curl https://{host}/v{X}/reservations/07f53b36-3f48-11e5-a151-feff819cdc9f &#x60;&#x60;&#x60;  Example response: &#x60;&#x60;&#x60; {   \&quot;id\&quot;: \&quot;07f53b36-3f48-11e5-a151-feff819cdc9f\&quot;,   \&quot;number\&quot;: 1092454812,   \&quot;quandooId\&quot;: \&quot;07f53b36-3f48-11e5-a151-feff819cdc9f\&quot;,   \&quot;status\&quot;: \&quot;CREATED\&quot;,   \&quot;startTime\&quot;: \&quot;2015-06-22T12:00:00+00:00\&quot;,   \&quot;endTime\&quot;: \&quot;2015-06-22T13:00:00+00:00\&quot;,   \&quot;capacity\&quot;: 4,   \&quot;merchantId\&quot;: 1384,   \&quot;customerId\&quot;: \&quot;35fff464-142c-48ac-a0c6-ed72a1615664\&quot;,   \&quot;promocode\&quot;: \&quot;SOME_CAMPAIGN_CODE\&quot;,   \&quot;extraInfo\&quot;: \&quot;request for baby chair\&quot;,   \&quot;links\&quot;: [     {       \&quot;href\&quot;: \&quot;https://{host}/v{X}/reservations/07f53b36-3f48-11e5-a151-feff819cdc9f\&quot;,       \&quot;method\&quot;: \&quot;PATCH\&quot;,       \&quot;rel\&quot;: \&quot;update\&quot;     }   ],   \&quot;createdAt\&quot;: \&quot;2015-06-01T15:21:54Z\&quot;,   \&quot;updatedAt\&quot;: \&quot;2015-06-01T18:45:30Z\&quot; } &#x60;&#x60;&#x60;
    # @param reservation_id Id of the reservation
    # @param [Hash] opts the optional parameters
    # @return [Array<(ReservationData, Fixnum, Hash)>] ReservationData data, response status code and response headers
    def get_reservation1_with_http_info(reservation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ReservationsApi.get_reservation1 ...'
      end
      # verify the required parameter 'reservation_id' is set
      if @api_client.config.client_side_validation && reservation_id.nil?
        fail ArgumentError, "Missing the required parameter 'reservation_id' when calling ReservationsApi.get_reservation1"
      end
      # resource path
      local_var_path = '/v1/reservations/{reservationId}'.sub('{' + 'reservationId' + '}', reservation_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['API_TOKEN']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ReservationData')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ReservationsApi#get_reservation1\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update reservation by id
    # This endpoint allows an agent to update a reservation by id. The id is agent-specific. The agent needs to be authenticated. ####Request: * **reservationId**: Agent-specific ID of the requested reservation. Taken as a path parameter. * **reservation.status**: New status for the reservation. When is present then all parameters below should be omitted! * **reservation.capacity**: The capacity (people count) of the reservation. * **reservation.areaId**: The ID of the area this reservation should be in. * **reservation.dateTime**: The date and time when the reservation will take place. Format: yyyy-MM-ddTHH:mm:ssZ.  For updating status request body should contain  only reservation.status. Valid status values depend on the current status of reservation and can be `CUSTOMER_CANCELED` or `RECONFIRMED`. * `CUSTOMER_CANCELED` is valid if current status is one of the below:     * CREATED     * CONFIRMED     * AUTOMATIC_CONFIRMED     * NOTIFICATION_REQUESTED     * NOTIFIED     * RECONFIRMED * `RECONFIRMED` is valid if current status is one of the below:     * CONFIRMED     * AUTOMATIC_CONFIRMED     * NOTIFICATION_REQUESTED     * NOTIFIED  If reservation.status field is not present then reservation data will be updated and reservation's status will be reset. Depending on `Automatic confirmation for online reservations` setting, reservation's status will be set to CREATED or AUTOMATIC_CONFIRMED.  ####Response: The endpoint will return `HTTP 200 - OK` if update was successful. It will return `HTTP 404 - Not Found` error if the reservation with the specified id could not be found. It will return `HTTP 403 - Forbidden` error if the agent is not authenticated, if the agent doesn't have permissions or the reservation doesn't belong to the  authenticated agent. It will return `HTTP 409 - Conflict` error if reservation has menu, smart offers, made by IOVOX, has conflict in status, time or other conflicts.  Example curl: ``` curl -H \"Content-Type: application/json\" -X PATCH -d ' {   \"reservation\": {     \"status\": \"CUSTOMER_CANCELED\"   } } ' https://{host}/v{X}/reservations/07f53b36-3f48-11e5-a151-feff819cdc9f ``` 
    # @param reservation_id Id of the reservation
    # @param body New reservation status
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def update_reservation1(reservation_id, body, opts = {})
      update_reservation1_with_http_info(reservation_id, body, opts)
      nil
    end

    # Update reservation by id
    # This endpoint allows an agent to update a reservation by id. The id is agent-specific. The agent needs to be authenticated. ####Request: * **reservationId**: Agent-specific ID of the requested reservation. Taken as a path parameter. * **reservation.status**: New status for the reservation. When is present then all parameters below should be omitted! * **reservation.capacity**: The capacity (people count) of the reservation. * **reservation.areaId**: The ID of the area this reservation should be in. * **reservation.dateTime**: The date and time when the reservation will take place. Format: yyyy-MM-ddTHH:mm:ssZ.  For updating status request body should contain  only reservation.status. Valid status values depend on the current status of reservation and can be &#x60;CUSTOMER_CANCELED&#x60; or &#x60;RECONFIRMED&#x60;. * &#x60;CUSTOMER_CANCELED&#x60; is valid if current status is one of the below:     * CREATED     * CONFIRMED     * AUTOMATIC_CONFIRMED     * NOTIFICATION_REQUESTED     * NOTIFIED     * RECONFIRMED * &#x60;RECONFIRMED&#x60; is valid if current status is one of the below:     * CONFIRMED     * AUTOMATIC_CONFIRMED     * NOTIFICATION_REQUESTED     * NOTIFIED  If reservation.status field is not present then reservation data will be updated and reservation&#39;s status will be reset. Depending on &#x60;Automatic confirmation for online reservations&#x60; setting, reservation&#39;s status will be set to CREATED or AUTOMATIC_CONFIRMED.  ####Response: The endpoint will return &#x60;HTTP 200 - OK&#x60; if update was successful. It will return &#x60;HTTP 404 - Not Found&#x60; error if the reservation with the specified id could not be found. It will return &#x60;HTTP 403 - Forbidden&#x60; error if the agent is not authenticated, if the agent doesn&#39;t have permissions or the reservation doesn&#39;t belong to the  authenticated agent. It will return &#x60;HTTP 409 - Conflict&#x60; error if reservation has menu, smart offers, made by IOVOX, has conflict in status, time or other conflicts.  Example curl: &#x60;&#x60;&#x60; curl -H \&quot;Content-Type: application/json\&quot; -X PATCH -d &#39; {   \&quot;reservation\&quot;: {     \&quot;status\&quot;: \&quot;CUSTOMER_CANCELED\&quot;   } } &#39; https://{host}/v{X}/reservations/07f53b36-3f48-11e5-a151-feff819cdc9f &#x60;&#x60;&#x60; 
    # @param reservation_id Id of the reservation
    # @param body New reservation status
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def update_reservation1_with_http_info(reservation_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ReservationsApi.update_reservation1 ...'
      end
      # verify the required parameter 'reservation_id' is set
      if @api_client.config.client_side_validation && reservation_id.nil?
        fail ArgumentError, "Missing the required parameter 'reservation_id' when calling ReservationsApi.update_reservation1"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling ReservationsApi.update_reservation1"
      end
      # resource path
      local_var_path = '/v1/reservations/{reservationId}'.sub('{' + 'reservationId' + '}', reservation_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['API_TOKEN']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ReservationsApi#update_reservation1\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
